// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html

// Note :
// La compilation du code provoque l'apparition de nombreux "Conseils"
// et "Avertissements".
// Ces messages concernent essentiellement des variables declarees et non
// utilisees. Ces variables ont ete utilisees pour la realisation des tableaux
// de resultats presentes dans le livre ou bien a des fins de mise au point.



unit Unit1;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Chapitre41: TMenuItem;
    Chapitre51: TMenuItem;
    Chapitre61: TMenuItem;
    Chapitre71: TMenuItem;
    Chapitre81: TMenuItem;
    Chapitre91: TMenuItem;
    Chapitre101: TMenuItem;
    Aide1: TMenuItem;
    Listing442page711: TMenuItem;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Listing52page81: TMenuItem;
    Listing54page131: TMenuItem;
    Listing56page241: TMenuItem;
    Listing58page281: TMenuItem;
    Listing510page371: TMenuItem;
    Listing512page431: TMenuItem;
    Listing62page1: TMenuItem;
    Listing69page331: TMenuItem;
    Listing611page411: TMenuItem;
    Listing612page421: TMenuItem;
    CheckBox1: TCheckBox;
    Listing73page201: TMenuItem;
    Listing76page401: TMenuItem;
    Listing78page511: TMenuItem;
    Listing710page631: TMenuItem;
    Listing711page671: TMenuItem;
    Listing83page201: TMenuItem;
    Listing85page341: TMenuItem;
    Listing93page141: TMenuItem;
    Listing96page231: TMenuItem;
    Listing913page391: TMenuItem;
    Listing109Page251: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Listing442page711Click(Sender: TObject);
    procedure Listing52page81Click(Sender: TObject);
    procedure Listing54page131Click(Sender: TObject);
    procedure Listing56page241Click(Sender: TObject);
    procedure Listing58page281Click(Sender: TObject);
    procedure Listing510page371Click(Sender: TObject);
    procedure Listing512page431Click(Sender: TObject);
    procedure Listing62page1Click(Sender: TObject);
    procedure Listing69page331Click(Sender: TObject);
    procedure Listing611page411Click(Sender: TObject);
    procedure Listing612page421Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Listing73page201Click(Sender: TObject);
    procedure Listing76page401Click(Sender: TObject);
    procedure Listing78page511Click(Sender: TObject);
    procedure Listing710page631Click(Sender: TObject);
    procedure Listing711page671Click(Sender: TObject);
    procedure Listing83page201Click(Sender: TObject);
    procedure Listing85page341Click(Sender: TObject);
    procedure Listing93page141Click(Sender: TObject);
    procedure Listing96page231Click(Sender: TObject);
    procedure Listing913page391Click(Sender: TObject);
    procedure Listing109Page251Click(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


uses U_TYPE_GRAPHES, U_GRAPHES, U_BASE_GRAPHES, Unit2, Unit3, Unit4, Unit5,
  Unit6, Unit7, Unit8;

procedure TForm1.Listing442page711Click(Sender: TObject);
Var G      : PTR_T_GRAPHE_LISTE;        {Graphe-liste}
    C      : T_GRAPHE_MATRICIEL;    {Graphe matriciel}
    F      : TextFile;      {Variable fichier-texte pour criture de graphes}
    NumTest: Byte;      {Numero de fichier-graphe}
    NumEd  : String;    {Le meme, edite}
    W      : PTArcCost;
begin

   Memo2.Clear;
   Memo2.Lines.Add('Generation de 3 graphes matriciels orientes de 20 sommets, densite 50%,');
   Memo2.Lines.Add('sans boucles, couts entre 100 et 200. Ecriture sur 3 fichiers de noms : ');
   Memo2.Lines.Add('MATRICE1,MATRICE2 et MATRICE3');
   Memo1.Clear;
   
   {Generation de 3 graphes matriciels orientes de 20 sommets, densit 50%,}
   {sans boucles, couts entre 100 et 200. Ecriture sur 3 fichiers de noms  }
   {MATRICE1,MATRICE2 et MATRICE3 (.MAT), sans pauses               }

   C := T_GRAPHE_MATRICIEL.Create;

   RandSeed := 179213;
   For NumTest := 1 to 3 do begin
      C.RandMatrix (20,0,not Simple,LoopLess, not Layered,
                  100,200,0,0.5,RandSeed,False);
      Str (NumTest,NumEd);
      AssignFile (F,'MATRICE'+NumEd+'.MAT');
      ReWrite (F);
      C.AFFMatrix (Memo1,'Test n '+NumEd,200,0);
      C.WriteMatrix (F,'Test n '+NumEd,200,0);
      CloseFile (F)
   End;

   C.Destroy;

   C := T_GRAPHE_MATRICIEL.Create;

   C.ReadMatrix ('MATRICE1.MAT');

   New(W);
   G:=C.Pack(W);

   G.Pause('le graphe matriciel est transform en graphe liste');

   G^.AffGraph (memo1, W,Nil,Nil,Nil,'Graphe-liste pour Matrice1',78,10);

   G.Pause('Fin d''affichage du graphe liste');

   G^.Destroy;
   
   C.Destroy;

end;


//--------------------------------------------
//----- tests des mthodes du chapitre 5 -----
//--------------------------------------------

procedure TForm1.Listing52page81Click(Sender: TObject);
Var G,H    : T_GRAPHE_LISTE;     {Graphe-liste G et son graphe inverse H}
    W      : PTArcCost; {Pointeur sur tableau de cots}
    Inv    : PTInverse; {Pointeur sur tableau arc --> arc inverse}

Begin
   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode BuildPreds');
   Memo2.Lines.Add ('BuildPreds dcrite dans le chapitre 5');
   Memo1.Clear;

   G := T_GRAPHE_LISTE.create;
   H := T_GRAPHE_LISTE.create;
   New (W);
   New (Inv);
   G.ReadGraph ('G5SOM.GRA',W,Nil,Nil);
   G.BuildPreds (H,Inv);
   G.AffGraph (Memo1,W,Nil,Nil,Nil,'Graphe G',78,MaxInt);
   G.Pause('Click pour avoir le graphe inverse');
   H.AffGraph (memo1,W,Nil,Nil,Inv,'Graphe inverse H',78,MaxInt);
   G.DESTROY;
   H.DESTROY;
end;


procedure TForm1.Listing54page131Click(Sender: TObject);
Var G     : T_GRAPHE_LISTE;     {Graphe-liste G}
    Layer : TNodeInfo; {N de niveau de chaque sommet}
    Sorted: TNodeInfo; {Sommets tries par n de niveau}
    NLayer: Node;      {Nombre de niveaux}
    x,y   : Node;
    ll:string;
Begin
   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode GetLayers');
   Memo2.Lines.Add ('GetLayers dcrite dans le chapitre 5');
   Memo1.Clear;

   G:=T_GRAPHE_LISTE.Create;

   {Lecture de G et decomposition en niveaux}
   G.ReadGraph ('EXPRESSI.GRA',Nil,Nil,Nil);
   G.GetLayers (NLayer,Layer,Sorted);
   {Affichage des resultats}
   Memo1.Lines.Add ('Nombre de niveaux  : '+IntToStr(NLayer));
   ll:='';
   For x := 1 to NLayer do begin
      Memo1.Lines.Add ('Sommets du niveau '+IntToStr(x)+': ');
      ll:='';
      For y := 1 to G.p_NX do If Layer[y] = x then ll:= ll+Inttostr(y)+' ';
      Memo1.Lines.Add(ll);
   End;
   G.Pause ('Click pour continuer...');

   G.DESTROY;
End;


procedure TForm1.Listing56page241Click(Sender: TObject);
Var G      : T_GRAPHE_LISTE;     {Graphe-liste G}
    NumVis : TNodeInfo; {Tableau des n de visite}
    Father : TNodeInfo; {Tableau de l'arborescence de visite}
    Circuit: TNodeInfo; {Tableau stockant un circuit}
    Size,x : Node;
    ll : string;
Begin
   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes d''exploration de graphe');
   Memo2.Lines.Add ('Mthode BFS, chapitre 5, listing 5.5');
   Memo2.Lines.Add ('Mthode DFS, chapitre 5, listing 5.5');
   Memo1.Clear;


   G:=T_GRAPHE_LISTE.CREATE;

   G.ReadGraph ('G7SOM.GRA',Nil,Nil,Nil);
   G.BFS (4,NumVis,Father);
   ll:='';
   Memo1.Lines.Add  ('Exploration en largeur, n de visite de chaque sommet:');
   For x := 1 to G.p_NX do ll:= ll+IntToStr(x)+':'+IntToStr(NumVis[x])+' ';
   Memo1.Lines.Add(ll);

   G.DFS (4,NumVis,Father);
   Memo1.Lines.Add  ('Exploration en profondeur: ');
   ll:='';
   For x := 1 to G.p_NX do
       ll:=ll+ IntToStr(x)+':'+IntToStr(NumVis[x])+' ';
   Memo1.Lines.Add (ll);

   G.GetCircuit (Circuit,Size);
   ll:= ('Circuit detecte : ');
   If Size = 0
   Then ll:=ll+'Aucun!'
   Else For x := 1 to Size do ll:=ll+IntToStr(Circuit[x])+' ';
   Memo1.Lines.Add (ll);
   G.Pause ('Click pour continuer...');
   G.DESTROY;
end;


procedure TForm1.Listing58page281Click(Sender: TObject);
Var G      : T_GRAPHE_LISTE;     {Graphe-liste G}
    CC     : TNodeInfo; {N de composante connexe de chaque sommet}
    NCC,x,y: Node;      {Nb de composantes, et variables de travail}
    ll : string;
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes de recherche de composantes connexes');
   Memo2.Lines.Add ('Mthode AllCC, chapitre 5, listing 5.7');
   Memo1.Clear;

   G:=T_GRAPHE_LISTE.CREATE;
   G.ReadGraph ('GB10SOM.GRA',Nil,Nil,Nil);
   G.AllCC (NCC,CC);
   Memo1.Lines.Add ('Nombre de composantes connexes: '+IntToStr(NCC));
   For x := 1 to NCC do begin
      ll:='Sommets de la composante '+IntToStr(x)+':';
      For y := 1 to G.GraphOrder do If CC[y] = x then ll:=ll+ ' '+IntToStr(y);
      Memo1.Lines.Add(ll);
   End;
   G.Pause ('Click pour continuer...');
   G.DESTROY;
End;





procedure TForm1.Listing510page371Click(Sender: TObject);
Const NTest        = 100;        {Nombre de graphes a tester}
      NS           = 1000;        {Nombre de sommets}
      Dens         = 0.05;       {Densite}
Var   G,H          : T_GRAPHE_LISTE;      {Graphe-liste G et son graphe inverse}
      NC1,NC2      : Node;       {Nb de composantes de chaque algo}
      CumNC        : Integer;    {Nb de composantes cumul}
      BegT, FinT1, FinT2   : TDateTime;       {Heure de debut des algos}
      CumT1,CumT2  : TDateTime;       {Dures cumules des algos}
      Test         : Integer;    {N de test}
      SCC          : TNodeInfo;  {N de composante des sommets}
      NG,NH        : TNodeInfo;  {N de visite dans G et H}
      Father       : TNodeInfo;  {Arborescence de visite de BFS (inutilis)}
      s,x          : Node;       {Variables de travail}

      KK, KKK, JJJ : longInt;
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes de recherche de composantes fortement connexes');
   Memo2.Lines.Add ('Mthode de Tarjan, nomme AllSCC, chapitre 5, listing 5.9');
   Memo1.Clear;


   G:=T_GRAPHE_LISTE.CREATE;
   H := T_GRAPHE_LISTE.create;

   RandSeed := 345267;           {Pour avoir un programme reproductible}
   CumT1    :=    0.0;           {Duree cumulee algorithme simple}
   CumT2    :=    0.0;           {Duree cumulee algorithme de Tarjan}
   CumNC    :=      0;           {Nb cumule de composantes}

   For Test := 1 to NTest do
   begin

      {Genere un graphe oriente sans faire de Randomize}
      G.RandGraph (NS,0,False,True,False,Nil, 0,0,Dens,RandSeed,False);

      BegT := G.Chrono;
      Memo1.Lines.Add ('debut '+FormatDateTime('hh:mm:ss:zzz',BegT));

      G.BuildPreds (H,Nil);      {Construit le graphe inverse de G}
      NC1 := 0;
      For s := 1 to G.p_NX do
         SCC[s] := 0;
      For s := 1 to G.p_NX do
        If SCC[s] = 0 then
        begin
         G.DFS (s,NG,Father);    {Explo de G, n de visite dans NG}
         H.DFS (s,NH,Father);    {Explo de H, n de visite dans NH}
         Inc (NC1);
         {Les sommets marques deux fois forment la composante de s}
         For x := 1 to G.p_NX do If (NG[x]>0) and (NH[x]>0) then
            SCC[x] := NC1;
        End;
      FinT1 := G.Chrono;
      CumT1 := CumT1 + (FinT1-BegT);
      CumNC := CumNC + NC1;

      {Algorithme de Tarjan}
      BegT := G.Chrono;
      G.AllSCC (NC2,SCC);

      FinT2 := G.Chrono;
      CumT2 := CumT2 + (FinT2-BegT);

      {Controle et message de progression}
      If (NC1 <> NC2) then
          G.Error ('Nb de composantes differentes!');

      Memo1.Lines.Add ('Test '+InttoStr(Test)+ ' duree1 = '+
           FormatDateTime('ss:zzz',FinT1-BegT) + ' duree2 = '+
           FormatDateTime('ss:zzz',FinT2-BegT) +
          ' OK! CumT1: '+FormatDateTime('hh:mm:ss:zzz',CumT1)+ ' CumT2: '+FormatDateTime('hh:mm:ss:zzz',CumT2));

   end;

   CumT1:=CumT1/NTest;
   CumT2:=CumT2/NTest;

   Memo1.Lines.Add ('Fin. Nb moyen de composantes:'+FloatToStr(CumNC/NTest)+
            ', CumT1/NTest: '+FormatDateTime('hh:mm:ss:zzz',CumT1)
            +', CumT2/NTest: '+FormatDateTime('hh:mm:ss:zzz',CumT2));
   G.Pause ('Click pour continuer...');

   H.DESTROY;
   G.DESTROY;

end;


procedure TForm1.Listing512page431Click(Sender: TObject);
Var G    : T_GRAPHE_LISTE;     {Graphe-liste G}
    Color: TNodeInfo; {Couleur de chaque sommet}
    Bip  : Boolean;   {Boolen True ssi G est biparti}
    x    : Node;
    ll   : string;

Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes de BiPartisme');
   Memo2.Lines.Add ('Mthode Bipartite, chapitre 5, listing 5.11');
   Memo1.Clear;


   G:=T_GRAPHE_LISTE.CREATE;

   G.ReadGraph ('HIDDENB8.GRA',Nil,Nil,Nil);
   G.Bipartite (Bip,Color);
   If not Bip
   Then Memo1.Lines.Add ('G n''est pas biparti')
   Else begin
      Memo1.Lines.Add ('G est biparti');
      ll:=   ('Sommets de X:');
      For x := 1 to G.GraphOrder do If Color[x]=1 then ll:=ll+ ' '+IntToStr(x);
      Memo1.Lines.Add(ll);
      ll:= 'Sommets de Y:';
      For x := 1 to G.GraphOrder do If Color[x]=2 then ll:=ll+ ' '+IntToStr(x);
      Memo1.Lines.Add(ll);
   End;
   G.Pause ('Click pour continuer ...');
   G.Destroy;
End;

//--------------------------------------------
//----- tests des mthodes du chapitre 6 -----
//--------------------------------------------


procedure TForm1.Listing62page1Click(Sender: TObject);
Var G    : T_GRAPHE_LISTE;     {Graphe-liste G}
    W    : TArcCost;  {Couts sur les arcs}
    s,t  : Node;      {Sommets de dpart et d'arrive}
    V    : TNodeCost; {Etiquettes de chaque sommet}
    P    : TNodeInfo; {Tableau codant l'arborescence des plus courts chemins}
    Path : TNodeInfo; {Tableau pour recuperer les chemins}
    Last : Node;      {Indice dans Path du dernier sommet}
    x,y  : Node;      {Variables-sommets de travail}
    ll : string;
begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes de Dijkstra');
   Memo2.Lines.Add ('Mthode Dijkstra, chapitre 6, listing 6.2');
   Memo1.Clear;

   G:=T_GRAPHE_LISTE.CREATE;

   G.ReadGraph ('GV8SOM.GRA',@W,Nil,Nil);
   G.AffGraph (Memo1,@W,Nil,Nil,Nil,'Graphe a traiter',78,99);
   s := 1;            {On part du sommet 1}
   t := 0;            {On veut les plus courts chemins vers tous les sommets}
   G.Dijkstra  (W,s,t,V,P);
   {Affichage des chemins trouves et de leurs valeurs}
   Memo1.Lines.Add('');
   ll:='';
   For x := 1 to G.p_NX do If P[x] <> 0 then begin
      ll:='Chemin de '+IntToStr(s)+'  '+IntToStr(x)+': ';
      ll:=ll+ 'Cout='+IntToStr(V[x])+'. Sommets:';
      G.GetPath (s,x,P,Path,Last);
      For y := 1 to Last do ll:=ll+ IntToStr(Path[y])+' ';
      Memo1.Lines.Add(ll);
   End;
   G.Pause ('Click pour continuer...');
   G.DESTROY;
end;


procedure TForm1.Listing69page331Click(Sender: TObject);
Var G   : PTR_T_GRAPHE_LISTE;     {Graphe-liste G}
    W   : PTArcCost;  {Couts sur les arcs}
    MV  : CostMatrix; {Distancier}
    MP  : NodeMatrix; {Matrice des predecesseurs}
    V   : TNodeCost;  {Etiquettes de chaque sommet, pour Dijkstra}
    P   : TNodeInfo;  {Arborescence des plus courts chemins, pour Dijkstra}
    Path: TNodeInfo;  {Tableau pour extraction des chemins}
    Last: Node;       {Nombre de sommets dans Path}
    i,j : Node;       {Variables-sommets de travail}
    Circ: Boolean;    {Indicateur de circuit negatif}
    ll : string;

Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode de Floyd');
   Memo2.Lines.Add ('Mthode Floyd, chapitre 6, listing 6.9');
   Memo1.Clear;

   New (G);
   New (W);

   G^:=T_GRAPHE_LISTE.CREATE;
   G^.readGraph  ('GV8SOM.GRA',W,Nil,Nil);
   G^.AffGraph (Memo1,W,Nil,Nil,Nil,'Graphe a traiter',78,99);
   Memo1.Lines.Add('');

   G^.Floyd(W^,MV,MP,Circ);

   If Circ
   Then Memo1.Lines.Add ('Circuit negatif detecte')
   Else begin
      Memo1.Lines.Add ('Matrice-distancier');
      For i := 1 to G^.p_NX do
      begin
         ll:='';
         For j := 1 to G^.p_NX do
         If MV[i,j]=MaxCost then
             ll:=ll+' Inf '
         else
             ll:=ll+IntToStr(MV[i,j])+' ';

         Memo1.Lines.Add(ll);
         ll:='';
      End;
      For i := 1 to G^.p_NX do begin
         G^.Dijkstra  (W^,i,0,V,P);
         G^.Compare   (TNodeCost(MV[i]),V,G^.p_NX)
      End
   End;

   // chemin 1-4
   Memo1.Lines.Add('impression chemin 1-4');
   i:=1;
   If i <> 0 then
     begin
     j:=4;
     G^.GetPath (i,j,MP[i],Path,Last);
     If Last = 0 Then
        Memo1.Lines.Add ('Pas de chemin !')
     Else
        begin
         ll:= ('Chemin trouve:');
         ll:='';
         For j := 1 to Last do ll:=ll+' '+IntToStr(Path[j]);
         Memo1.Lines.Add(ll);
        End;
        Memo1.Lines.Add('');
     End;

   // chemin 2-8
   Memo1.Lines.Add('impression chemin 2-8');
   i:=2;
   If i <> 0 then
     begin
     j:=8;
     G^.GetPath (i,j,MP[i],Path,Last);
     If Last = 0 Then
         Memo1.Lines.Add ('Pas de chemin !')
     Else
         begin
         ll:= ('Chemin trouve:');
         ll:='';
         For j := 1 to Last do ll:=ll+' '+IntToStr(Path[j]);
         Memo1.Lines.Add(ll);
         End;
         Memo1.Lines.Add('');
     End;

   G.Pause   ('Click pour continuer');
   G.Destroy;
   dispose(G);    // correspond au new de depart
   Dispose (W);

end;


procedure TForm1.Listing611page411Click(Sender: TObject);
Var G   : PTR_T_GRAPHE_LISTE;     {Graphe de projet}
    W   : PTArcCost;  {Dures sur les arcs}
    V   : TNodeCost;  {Dates au plus tot}
    P   : TNodeInfo;  {Arborescence des plus courts chemins}
    Path: TNodeInfo;  {Tableau pour extraction des chemins}
    Last: Node;       {Nombre de sommets dans Path}
    x   : Node;       {Variable de travail}
    ll : String;

Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode Schedule');
   Memo2.Lines.Add ('Mthode Schedule, chapitre 6, listing 6.10');
   Memo1.Clear;

   New (G);
   G^:=T_GRAPHE_LISTE.CREATE;

   New (W);

   G^.ReadGraph  ('ORDO.GRA',W,Nil,Nil);

   G^.AffGraph (Memo1,W,Nil,Nil,Nil,'Graphe a traiter',78,99);
   Memo1.Lines.Add('');
   {Tache 11=debut de projet, tache 12=fin de projet}
   G^.Schedule   (W^,11,12,V,P);
   Memo1.Lines.Add('Duree du projet: '+IntToSTr(V[12]));
   G^.GetPath    (11,12,P,Path,Last);
   Memo1.Lines.Add ('Chemin critique:');
   ll:='';
   For x := 1 to Last do ll:=ll+' '+IntToStr(Path[x]);
   Memo1.Lines.Add(ll);

   G^.Pause ('Un Click pour continuer...');
   G^.DESTROY;
   Dispose (G);
   Dispose (W);
End;


procedure TForm1.Listing612page421Click(Sender: TObject);
Const NTest =  100;                   {Nombre de graphes a tester}
      NS    =  900;                   {Nombre de sommets}
      Dens  =  0.8;                   {Densite}
Type  TName = Array[1..6] of String;  {Type pour noms des algorithmes}
Var   G     : PTR_T_GRAPHE_LISTE;     {Graphe-liste G, alloue dans le tas}
      H :T_GRAPHE_LISTE;
      W     : TArcCost;        {Tableau de couts sur les arcs}
      s     : Node;            {Sommet de depart}
      V     : TNodeCost;       {Couts des plus courts chemins}
      P     : TNodeInfo;       {Arborescence des plus courts chemins}
      NegCir: Boolean;         {Detection circuit negatif (Bellman)}
      BegT,Dur  : TDateTime;            {Heure de debut des algos}
      CumT  : Array[1..6] of TDateTime;    {Durees cumulees des algos}
      Test  : Integer;                {N de test}
      NumAlg: Integer;                {N d'algorithme}
Const Name  : TName =                 {Table des noms d'algorithmes}
              ('Dijkstra','DijHeap',
               'Bucket',  'Bellman',
               'Fifo'    ,'Esopo');
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes de cheminement');
   Memo2.Lines.Add ('Mthodes Dijkstra/DijHeap/Bucket/Bellman/FIFO/Esopo');
   Memo2.Lines.Add (' chapitre 6, listing 6.12');
   Memo1.Clear;
   Memo1.Lines.add('Patientez...'+IntToStr(NTest)+' appels aux mthodes');

   New(G);
   G^:=T_GRAPHE_LISTE.CREATE;

   RandSeed := 345267;       {Pour avoir un programme reproductible}
   For NumAlg := 1 to 6 do CumT[NumAlg] := 0.0;
   s := 1;

   For Test := 1 to NTest do
   begin
      {Genere un graphe oriente, couts entre 0 et 1000}
      G^.RandGraph (NS,0,False,True,False,@W, 0,1000,Dens,RandSeed,False);

      BegT := G^.Chrono;                 {Test de l'algo de Dijkstra}
      G^.Dijkstra (W,s,0,V,P);
      CumT[1] := CumT[1]+G^.Chrono-BegT;

      BegT := G^.Chrono;                 {Dijkstra avec tas}
      G^.DijHeap (W,s,0,V,P);
      CumT[2] := CumT[2]+G^.Chrono-BegT;

      BegT := G^.Chrono;                 {Dijkstra a buckets}
      G^.Bucket (W,s,0,V,P);
      CumT[3] := CumT[3]+G^.Chrono-BegT;

      BegT := G^.Chrono;                 {Algo de Bellman}
      G^.Bellman (W,s,V,P,NegCir);
      CumT[4] := CumT[4]+G^.Chrono-BegT;

      BegT := G^.Chrono;                 {Algorithme FIFO}
      G^.FIFO (W,s,V,P);
      CumT[5] := CumT[5]+G^.Chrono-BegT;

      BegT := G^.Chrono;                 {Algorithme de d'Esopo et Pape}
      G^.Esopo (W,s,V,P);
      CumT[6] := CumT[6]+G^.Chrono-BegT;
   End;

   For NumAlg := 1 to 6 do
   begin
     Dur := CumT[NumAlg]/NTest;
     Memo1.Lines.Add (Name[NumAlg]+': '+FormatDateTime('hh:mm:ss:zzz',dur));
   end;

   G^.Pause ('Click Pour continuer...');

   G^.DESTROY;
   Dispose(G);
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Memo1.Clear;
  Memo2.Clear;
end;


//--------------------------------------------
//----- tests des mthodes du chapitre 7 -----
//--------------------------------------------

procedure TForm1.Listing73page201Click(Sender: TObject);
Var G  : PTR_T_GRAPHE_LISTE;     {Graphe-liste G}
    C  : PTArcCost;  {Capacites sur les arcs}
    F  : Cost;       {Flot total}
    PHI: TArcCost;   {Flots sur les arcs}
    s,t: Node;       {Source et puits}
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode de Fulkerson');
   Memo2.Lines.Add ('chapitre 7, listing 7.3');
   Memo1.Clear;

   New(G);
   G^:=T_GRAPHE_LISTE.CREATE;

   New (C);
   G^.ReadGraph  ('FLOT-2',C,Nil,Nil);
   G^.AffGraph (Memo1, C,Nil,Nil,Nil,'Graphe a traiter',78,99);
   s :=  13;
   t :=  14;
   G^.Fulkerson        (C^,s,t,F,PHI);

   G^.CheckFlow  (C^,s,t,F,PHI);
   Memo1.Lines.Add( 'Flot total: ' + IntToStr(F));
   G^.Pause ('Click pour continuer...');

   G^.DESTROY;
   dispose(G);
   Dispose (C);

end;


procedure TForm1.Listing76page401Click(Sender: TObject);
begin
   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes Fulkerson/Scaling/Ahuja');
   Memo2.Lines.Add ('chapitre 7, listing 7.6');
   Memo1.Clear;
   Unit2.Form2.ShowModal;
end;


procedure TForm1.Listing78page511Click(Sender: TObject);
Var G  : PTR_T_GRAPHE_LISTE;     {Graphe-liste G}
    C  : PTArcCost;  {Capacites sur les arcs}
    W  : PTArcCost;  {Couts sur les arcs}
    F  : Cost;       {Flot total}
    K  : Cost;       {Cout total}
    PHI: TArcCost;   {Flots sur les arcs}
    s,t: Node;       {Source et puits}
    p : ARCNUM;
    BegT : TDateTime;
    FinT : TDateTime;
    Dur  : TDateTime;

Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode Busacker');
   Memo2.Lines.Add ('chapitre 7, listing 7.8');
   Memo1.Clear;

   New (G);
   G^:= T_GRAPHE_LISTE.Create;

   New (C);
   New (W);

   RandSeed := 345267;

//   G^.ReadGraph  ('CAPACOST',C,W,Nil);
//   G^.AffGraph (Memo1,C,W,Nil,Nil,'Graphe a traiter',78,99);

  Memo1.Lines.add ('Gnration du graphe...');
  G^.RandGraph (1000,0,False,True,False,C,1,1000,0.05,1741913,False);
  For p := 1 to G^.p_M do
   begin
        W^[p] := 1 + Random(1000);
        C^[p] := 1 + Random(1000);
   end;

   BegT := G^.Chrono;

   s :=  1;
   t :=  G^.p_NX;
   G^.Busacker   (C^,W^,s,t,MaxCost,F,K,PHI);


   dur := G^.Chrono-BegT;
   Memo1.Lines.Add ('Duree = '+FormatDateTime('hh:mm:ss:zzz',dur));

   G^.CheckFlow  (C^,s,t,F,PHI);
   Memo1.Lines.add('Debit total: '+FloatToStr(F)+', Cout total: '+FloatToStr(K));
   G^.Pause ('Click pour continuer...');
 //  G^.AffGraph (Memo1,C,W,@Phi,Nil,'Resultats (capa,cout,flux)',78,0);

   G^.Pause ('Click pour continuer...');
   G^.Destroy;
   Dispose (G);
   Dispose (C);
   Dispose (W);

end;


procedure TForm1.Listing710page631Click(Sender: TObject);
Var G   : PTR_T_GRAPHE_LISTE;     {Graphe-liste G}
    C   : PTArcCost;  {Capacites}
    s,t : Node;       {Source et puits}
    F   : Cost;
    PHI : PTArcCost;  {Flots sur les arcs}
    BegT: TDateTime;
    Card: Node;
    Mate: TNodeInfo;

Procedure AddArc (var G:T_GRAPHE_LISTE; x,y:Node);
Var z: Node;
    p: ArcNum;
Begin
   With G do begin
      For p := G.p_M downto p_Head[x+1] do p_Succ[p+1] := p_Succ[p];
      p := p_Head[x+1];
      p_Succ[p] := y;
      For z := x+1 to p_NX+p_NY+1 do
          p_Head[z]:=p_Head[z]+1;
      p_M:=p_M+1;
   End
End;

Procedure MakeNetwork (var G:T_GRAPHE_LISTE; var s,t:Node; var C:TArcCost);
Var k        : ArcNum;
    x,y,SavNX: Node;
Begin
   With G do begin
      p_M       := p_M div 2;
      For x := p_NX+1 to p_NX+p_NY+3 do p_Head[x] := p_M+1;
      SavNX   := p_NX;
      p_NX      := p_NX+p_NY+2;
      p_NY      := 0;
      p_Simple  := False;
      s       := p_NX-1;
      t       := p_NX;
      For x := 1 to SavNX do AddArc (G,s,x);
      For y := SavNX+1 to p_NX-2 do AddArc (G,y,t);
      For x := 1 to p_NX do
      For k := p_Head[x] to p_Head[x+1] do
      If (x = s) or (p_Succ[k] = t) then C[k] := 1 else C[k] := MaxCost
   End
End;

Begin

   Memo2.Clear;
   Memo2.Lines.Add('Comparaison de BipMatch avec Fulkerson et Ahuja');
   Memo2.Lines.Add ('chapitre 7, listing 7.10');
   Memo1.Clear;

   New (G);
   New (C);
   New (Phi);

   G^:=T_GRAPHE_LISTE.Create;

   Memo1.Lines.Add ('Generation aleatoire d''un graphe biparti');
   G^.RandGraph (100,100,Simple,LoopLess,not Layered, Nil,
              0,0,0.005,1741913,False);

   If G^.GraphOrder <= 10 then
   G^.AffGraph  (Memo1,Nil,Nil,Nil,Nil,'Graphe obtenu',78,99);

   Memo1.Lines.Add ('M='+Inttostr(G^.p_M));
   Memo1.Lines.Add ('Appel de BipMatch');
   BegT        := G^.Chrono;
   G^.BipMatch    (Card,Mate);
   Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G^.Chrono-BegT));

   Memo1.Lines.Add ('Card : '+IntToStr(Card));
   If G^.GraphOrder<= 10 then
   For s := 1 to G^.p_NX do
       Memo1.Lines.Add ('Mate of '+IntTostr(s)+' is '+IntToStr(Mate[s]));
   G^.Pause       ('Click pour continuer...');

   Memo1.Lines.Add('');
   Memo1.Lines.Add     ('Construction du reseau');
   MakeNetWork (G^,s,t,C^);
   If G^.GraphOrder <= 10 then
   G^.AffGraph  (Memo1,C,Nil,Nil,Nil,'Reseau obtenu',78,99);

   Memo1.Lines.Add     ('Appel de Fulkerson avec s='+IntToStr(s)+' et t='+IntToStr(t));
   BegT        := G^.Chrono;
   G^.Fulkerson   (C^,s,t,F,Phi^); {Ou: Ahuja!}
   Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G^.Chrono-BegT));
   If G^.GraphOrder <= 10 then
   G^.AffGraph  (Memo1,C,Phi,Nil,Nil,'Resultats (capa,cout,flux)',78,99);
   Memo1.Lines.Add     ('Debit total: '+FloatToStr(F));
   G^.CheckFlow   (C^,s,t,F,Phi^);

   G^.Pause ('Click pour continuer...');
   G^.Destroy;
   Dispose (G);
   Dispose (C);
   Dispose (Phi);


end;


procedure TForm1.Listing711page671Click(Sender: TObject);
Var G   : T_GRAPHE_MATRICIEL;   {Graphe matriciel biparti}
    Card: Node;     {Cardinal de l'affectation (nb d'aretes)}
    K   : Cost;     {Cout total}
    Mate: TNodeInfo;{Sommet affecte a tout sommet (0 si pas affecte)}
    x   : Node;
    BegT: TDateTime;
    ll : String;
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode Assignment');
   Memo2.Lines.Add ('chapitre 7, listing 7.11');
   Memo1.Clear;

   G:=T_GRAPHE_MATRICIEL.CREATE;

   G.ReadMatrix  ('MATCH10.MAT');
   G.AFFMatrix (Memo1,'Probleme d''affectation',78,99);
   Memo1.Lines.Add('');
   Memo1.Lines.Add('Execution de Assignment...');
   BegT := G.Chrono;
   G.Assignment  (Card,K,Mate);
   Memo1.Lines.Add('');
   Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G.Chrono-BegT));

   Memo1.Lines.Add ('Cardinal: '+IntToStr(Card)+' Cout: '+IntToStr(K));
   Memo1.Lines.Add ('Detail affectation (noeud de X:noeud affecte dans Y):');
   ll:='';
   For x := 1 to G.p_NX do
      ll:=ll+ IntToStr(x)+':'+IntToStr(Mate[x])+' ';
   Memo1.Lines.Add(ll);
   G.Pause ('Click pour continuer...');
   G.Destroy;
end;


//--------------------------------------------
//----- tests des mthodes du chapitre 8 -----
//--------------------------------------------

procedure TForm1.Listing83page201Click(Sender: TObject);
begin
 Memo2.Clear;
 Memo2.Lines.Add('Test de la mthode de Kruskal');
 Memo2.Lines.Add ('chapitre 8, listing 8.3');
 Memo1.Clear;

 Unit3.Form3.Showmodal;
end;


procedure TForm1.Listing85page341Click(Sender: TObject);
Const s          : Node = 1;  {Racine fixee}
Var   G          : T_GRAPHE_LISTE;
      W          : PTArcCost;
      Weight     : Cost;
      BFN        : TNodeInfo;
      Father     : TNodeInfo;
      x          : Node;
      BegTime    : TDateTime;
      NTest      : Byte;
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode de Edmonds');
   Memo2.Lines.Add ('chapitre 8, listing 8.5');
   Memo1.Clear;

   G:=T_GRAPHE_LISTE.Create;
   New (W);
   G.ReadGraph  ('ARBOR-1',W,Nil,Nil);
   G.AffGraph (Memo1,W,Nil,Nil,Nil,'Graphe a traiter',78,99);
   G.BFS        (s,BFN,Father);
   For x := 1 to G.GraphOrder do
   If BFN[x] = 0 then G.Error ('Le sommet impose n''est pas racine de G');
   Memo1.Lines.Add ('Calcul de l''ARPM...');
   BegTime := G.Chrono;
   For NTest := 1 to 1 do
   G.Edmonds    (W^,s,Weight,Father);
   Memo1.Lines.Add('');
   Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G.Chrono-BegTime));

   Memo1.Lines.Add    ('Poids total : '+IntToStr(Weight));
   Memo1.Lines.Add    ('Arcs de l''arborescence: ');
   For x := 1 to G.GraphOrder do
    Memo1.Lines.Add ('x:'+IntToStr(x)+' has father:'+IntToStr(Father[x]));
   Memo1.Lines.Add('');
   G.Pause ('Click pour continuer...');
   G.DESTROY;
   dispose(W);
end;


//--------------------------------------------
//----- tests des mthodes du chapitre 9 -----
//--------------------------------------------


procedure TForm1.Listing93page141Click(Sender: TObject);
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test des mthodes EulerChain et EulerPath');
   Memo2.Lines.Add ('chapitre 9, listing 9.3');
   Memo1.Clear;

   Form4.Showmodal;

end;

procedure TForm1.Listing96page231Click(Sender: TObject);
Begin

   Memo2.Clear;
   Memo2.Lines.Add('Test de la mthode Postman');
   Memo2.Lines.Add ('chapitre 9, listing 9.6');
   Memo1.Clear;

   Form5.Showmodal;
end;


procedure TForm1.Listing913page391Click(Sender: TObject);
begin

   Memo2.Clear;
   Memo2.Lines.Add('Tests des Heuristiques pour le PVC');
   Memo2.Lines.Add ('chapitre 9, listing 9.13');
   Memo1.Clear;

   Form6.Showmodal;

end;

procedure TForm1.Listing109Page251Click(Sender: TObject);
begin

   Memo2.Clear;
   Memo2.Lines.Add('Tests des mthodes de coloration');
   Memo2.Lines.Add ('chapitre 10, listing 10.9');
   Memo1.Clear;

   Form7.Showmodal;

end;

procedure TForm1.Aide1Click(Sender: TObject);
begin
  Form8.Showmodal;
end;

end.
