// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html



// Comparaison des mthodes Ahuja, Fulkerson et scaling


unit Unit2;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

  uses U_TYPE_GRAPHES, U_GRAPHES, U_BASE_GRAPHES, Unit1;

procedure TForm2.Button1Click(Sender: TObject);
Var G     : PTR_T_GRAPHE_LISTE;     {Graphe-liste G}
    C     : PTArcCost;  {capacite sur les arcs}
    F     : Cost;       {Flot total}
    PHI   : TArcCost;   {Flots sur les arcs}
    NumAlg: Byte;       {Num algorithme a tester}
    BegT  : TDateTime;       {Heure de debut}
    EndT  : TDateTime;       {Heure de fin}
    nom : string;
Begin

   New(C);
   New (G);
   G^:=T_GRAPHE_LISTE.CREATE;


   Form1.Memo1.Lines.Add ('Generation du graphe...');
   G^.RandGraph (700,0,False,True,False,C, 1,1000,0.01,1741913,False);

   If (RadioButton1.Checked=True) Then
   begin
      NumAlg:=1;
      nom:='Fulkerson';
   end
   else
     If (RadioButton2.Checked=True) Then
     begin
       NumAlg:=2;
       nom:='Scaling';
     end
     else
     begin
       NumAlg:=3;
       nom:='Ahuja';
     end;

   Form1.Memo1.Lines.Add ('--------------------------------');
   Form1.Memo1.Lines.Add ('Execution... de '+nom);
   BegT := G^.Chrono;
   With G^ do Case NumAlg of
      1: G^.Fulkerson (C^,1,G^.p_NX+G^.p_NY,F,PHI);
      2: G^.Scaling   (C^,1,G^.p_NX+G^.p_NY,F,PHI);
      3: G^.Ahuja     (C^,1,G^.p_NX+G^.p_NY,F,PHI)
   End;
   EndT := G^.Chrono-BegT;

   Form1.Memo1.Lines.Add ('Verification...');
   G^.CheckFlow (C^,1,G^.p_NX+G^.p_NY,F,PHI);
   Form1.Memo1.Lines.Add   ('Duree (s) : '+FormatDateTime('hh:mm:ss:zzz',G.Chrono-BegT));

   Form1.Memo1.Lines.Add   ('Flot total: '+FloatToStr(F));

   G^.Pause   ('Click pour continuer...');
   G^.DESTROY;
   Dispose (G);
   Dispose (C);

   Form2.Close;

end;

end.
