// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html


unit Unit3;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm3 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form3: TForm3;

implementation

  uses U_TYPE_GRAPHES, U_GRAPHES, U_BASE_GRAPHES, Unit1;

{$R *.dfm}

procedure TForm3.Button1Click(Sender: TObject);
Const Name       = 'G6Tree.Gra'; {Nom du fichier a lire}
      NNode      = 1000;          {Nb de sommets a generer}
      Densite    = 0.05;          {Densite du graphe a generer}

Var   G          : T_GRAPHE_LISTE;        {Graphe-liste G}
      W          : PTArcCost;    {Poids sur les aretes}
      Weight     : Cost;         {Poids de l'ARPM}
      NEdge,x    : Node;         {Nombre d'aretes de l'arbre}
      Node1,Node2: TNodeInfo;    {Extremites des NEdge aretes trouvees}
      Rep        : Char;
      BegTime    : TDateTime;
      ll : string;
Begin

   G:=T_GRAPHE_LISTE.Create;

   New (W);

   Form1.Memo1.Lines.Add ('Calcul d''arbre recouvrant de poids minimal (ARPM)');
   Form1.Memo1.Lines.Add('');

   If radiobutton1.Checked=True then
      G.ReadGraph (Name,W,Nil,Nil)
   else
      Begin
              Form1.Memo1.Lines.Add ('Generation du graphe...');
              G.RandGraph (NNode,0,Simple,LoopLess,not Layered,W,
                         1,1000,Densite,1239867,False);
              Form1.Memo1.Lines.Add ('Nombre d''arcs M = '+IntToStr(G.p_M));
      End;


   Form1.Memo1.Lines.Add ('Calcul de l''ARPM...');
   BegTime := G.Chrono;
   G.Prim (W^,Weight,NEdge,Node1,Node2);
   Form1.Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G.Chrono-BegTime));

   Form1.Memo1.Lines.Add ('Nombre d''aretes trouvees: '+IntToStr(NEdge));
   If NEdge < G.GraphOrder-1 then
       Form1.Memo1.Lines.Add ('G n''est pas connexe!');

   Form1.Memo1.Lines.Add ('Poids total             : '+IntToStr(Weight));

   Form1.Memo1.Lines.Add   ('Liste des aretes        : ');
   ll:='';
      For x := 1 to NEdge do
         ll:=ll+ '['+IntToStr(Node1[x])+','+IntToStr(Node2[x])+'] ';
      Form1.Memo1.Lines.Add(ll);


   G.PAUSE ('Click pour terminer...');

   G.Destroy;
   dispose(W);
   Form3.Close;
end;


end.
