// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html


unit Unit4;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;

type
  TForm4 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

uses U_TYPE_GRAPHES, U_BASE_GRAPHES, U_GRAPHES, Unit1;

procedure TForm4.Button1Click(Sender: TObject);
Var   G    : T_GRAPHE_LISTE;   {Graphe-liste G}
      Found: Boolean; {Indique si le parcours a ete trouve}
      Walk : TSucc;   {Parcours eulerien}
      Last : ArcNum;  {Nombre de noeuds du parcours}
      Nom  : String;  {Nom du fichier}
      x    : Node;
      ll : String;
Begin

   G:=T_GRAPHE_LISTE.Create;

   Nom:=Edit1.Text;


   G.ReadGraph  (Nom,Nil,Nil,Nil);
   G.AffGraph (Form1.Memo1,Nil,Nil,Nil,Nil,'Graphe a traiter',78,99);
   If G.p_Simple then begin
      Form1.Memo1.Lines.Add ('Graphe simple avec '+IntToStr(G.p_M div 2)+' aretes');
      Form1.Memo1.Lines.Add ('Execution d''EulerChain...');
      G.EulerChain (Found,Walk,Last)
   End
   Else begin
      Form1.Memo1.Lines.Add ('Graphe oriente avec '+IntToStr(G.p_M)+' arcs');
      Form1.Memo1.Lines.Add ('Execution d''EulerPath...');
      G.EulerPath (Found,Walk,Last)
   End;
   If Found then begin
      Form1.Memo1.Lines.Add ('Parcours eulerien trouve + '+IntToStr(Last)+' sommets:');
      ll:='';
      For x := 1 to Last do ll:=ll+ IntToStr(Walk[x])+' ';
      Form1.Memo1.Lines.Add(ll);
   End
   Else Form1.Memo1.Lines.Add ('Ce graphe n''a pas de parcours eulerien!');
   G.Pause ('Click pour continuer...');

   G.DESTROY;
   Form4.Close;

end;

end.
