// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html


unit Unit7;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm7 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label1: TLabel;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Button1: TButton;
    CheckBox1: TCheckBox;
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form7: TForm7;

implementation

{$R *.dfm}

uses U_TYPE_GRAPHES, U_BASE_GRAPHES, U_GRAPHES,Unit1;

procedure TForm7.RadioButton2Click(Sender: TObject);
begin
  Edit1.Enabled := False;
end;

procedure TForm7.RadioButton1Click(Sender: TObject);
begin
  Edit1.Enabled := True;
end;

procedure TForm7.Button1Click(Sender: TObject);
CONST

NNodes  =        30;  {Taille du graphe alatoire}
Density =       0.5;  {Densit}
Seed    = 197211719;  {Germe du generateur alatoire}
Coef    =    0.9950;  {Recuit: coef de refroidissement}
Eps     =      0.01;  {Recuit: temperature d'arrt}
NPass   =        10;  {Recuit: nombre de passes}
NT      =        20;  {Tabou : taille de la liste taboue (max 50)}
NItMax  =       2000; {Tabou : nb max d'itrations par k-coloration}
MaxDown =     50000;  {Backtrack: nb max descentes ds l'arborescence}
NTest   =        50;  {Nombre de tests}



VAR

G      : T_GRAPHE_LISTE;       {Graphe simple  colorer}
Color  : TNodeInfo;   {Tableau des couleurs des sommets}
NC     : Node;        {Nombre de couleurs}
Typ    : Char;        {Rponse type de traitement}
Met    : Byte;        {Rponse sur mthode  employer}
FName  : String;      {Nom du fichier}
TDeb   : TDateTime;   {Heure de dbut}
NIter  : LongInt;     {Nb d'itrations (tabou et recuit)}
NDown  : LongInt;     {Nombre de noeuds (Backtrack)}
x      : INTEGER;     {Variable de travail}
ll : string;

//-- partie 2
//F:File of text;
T:Array[1..200] of Node;
NOPT:Integer;
SavSeed: LongInt;
SumT   : TDateTime;   {Duree totale des tests}
SumTGen: TDateTime;   {Duree totale des RandGraph}
GenDeb : TDateTime;   {Heure debut RandGraph}
Test   : Integer;     {Numero de test}
SumNC  : LongInt;     {Nombre de couleurs (total)}



BEGIN

if CheckBox1.Checked=False Then
begin

   G:=T_GRAPHE_LISTE.Create;

   Form1.Memo1.lines.Add ('METHODES DE COLORATION');
   Form1.Memo1.lines.Add('');

   If (radiobutton1.Checked=True) Then
     Typ:='F'
   else
     Typ:='A';

   Met:=Combobox1.ItemIndex+1;

   If Typ = 'F'then begin
      FName:=Edit1.Text;
      G.ReadGraph  (FName,Nil,Nil,Nil)
   End
   Else begin
      Form1.Memo1.lines.Add    ('Generation aleatoire...');
      G.RandGraph  (NNodes,0,Simple,LoopLess,not Layered,
                  Nil, 0,0,Density,Seed,False)


   End;

   If G.GraphOrder <= 20
   Then G.AffGraph (Form1.memo1,Nil,Nil,Nil,Nil,'A traiter:',78,20);
   Form1.Memo1.lines.Add('');
   Form1.Memo1.lines.Add ('Borne sup BS1: '+floattostr(G.BS1));
   Form1.Memo1.lines.Add ('Borne sup BS2: '+floattostr(G.BS2));
   Form1.Memo1.lines.Add ('Borne sup BS3: '+floattostr(G.BS3));


   TDeb := G.Chrono;


   Case Met of
      1: G.FFS       (Color,NC);
      2: G.LFS       (Color,NC);
      3: G.SLS       (Color,NC);
      4: G.DSatur    (Color,NC);
      5: G.Local     (Color,NC);
      6: G.SimAn     (Form1.memo1, G.GraphOrder,Coef,Eps,
                    NPass,Seed,False,Color,NC,NIter);
      7: G.TabuCol   (NT,NItMax,Color,NC,NIter);
      8: G.Backtrack (MaxDown,Color,NC,NDown)
   End;



   Form1.Memo1.Lines.Add ('Duree: '+FormatDateTime('hh:mm:ss:zzz',G.Chrono-TDeb));

   G.Check   (Color,NC);
   Form1.Memo1.lines.Add ('Couleurs trouvees      : '+inttostr(NC));
   Form1.Memo1.lines.Add   ('Couleur de chaque noeud:   ');
   ll:='';
   For x := 1 to G.GraphOrder do
       ll:=ll+ inttostr(x)+':'+inttostr(Color[x])+' ';
   Form1.Memo1.lines.Add(ll);
   If (Met=6) or (Met=7)
   Then Form1.Memo1.lines.Add ('Nombre d''itrations   : '+Inttostr(NIter));
   If Met = 8 then begin
      Form1.Memo1.lines.Add ('Noeuds construits      : '+Inttostr(NDown));
      If NDown < MaxDown then Form1.Memo1.lines.Add (' (Optimum trouv)')
                         else Form1.Memo1.lines.Add (' (Optimum non trouv)')
   End;
   G.Pause ('test termin');
   G.Destroy;
   Form7.Close;
end
else
begin

   G:=T_GRAPHE_LISTE.Create;
   Met:=Combobox1.ItemIndex+1;
   
   RandSeed :=   Seed;
   SumNC    :=      0;
   SumTGen  :=    0.0;
   TDeb     := G.Chrono;

   NOpt := 0;
   For Test := 1 to NTest do begin
      Form1.Memo1.Lines.Add ('Test n '+IntToStr(Test)+'... ');
      GenDeb := G.Chrono;
      G.RandGraph (NNodes,0,Simple,LoopLess,not Layered,
                 Nil, 0,0,Density,RandSeed,False);
      SumTGen := SumTGen + (G.Chrono-GenDeb);
      Case Met of
         1: G.FFS   (Color,NC);
         2: G.LFS   (Color,NC);
         3: G.SLS   (Color,NC);
         4: G.DSatur(Color,NC);
         5: G.Local (Color,NC);
         6: Begin
               SavSeed := RandSeed;
               G.SimAn (Form1.Memo1,G.GraphOrder,Coef,Eps,NPass,Seed,False,Color,NC,NIter);
               RandSeed := SavSeed
            End;
         7: G.TabuCol   (NT,NItMax,Color,NC,NIter);
         8: G.Backtrack (MaxDown,Color,NC,NDown);
      End;
      SumNC := SumNC + NC;
      Form1.Memo1.Lines.Add ('OK! NC: '+IntToStr(NC));
   If NC = T[Test] then Inc (NOpt)
   End;
   SumT := G.Chrono-TDeb;
   Form1.Memo1.Lines.Add('');
   Form1.Memo1.Lines.Add ('Duree totale, RandGraph inclus: '+FormatDateTime('hh:mm:ss:zzz',SumT));
   Form1.Memo1.Lines.Add ('Duree totale des RandGraph    : '+FormatDateTime('hh:mm:ss:zzz',SumTGen));
   Form1.Memo1.Lines.Add ('Duree moyenne de la methode   : '+FormatDateTime('hh:mm:ss:zzz',(SumT-SumTGen)/NTest));
   Form1.Memo1.Lines.Add ('Nombre moyen de couleurs      : '+FloattoStr(SumNC/NTest));
   Form1.Memo1.Lines.Add ('NOPT: '+IntToStr(Nopt));
   G.Pause ('Click pour continuer');
   G.Destroy;
end;
END;


end.
